// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.data;

import java.io.Serializable;
import java.util.ArrayList;

public class User implements Serializable {

	private static final long serialVersionUID = 4358322992207803438L;
	private String id;
	private String name;
	private String ip;
	private int port;
	private String dept;
	private String hp;
	private String logout;
	private boolean flag;
	private String pic;

	public User(User user) {
		this.id = user.getID();
		this.ip = user.getIP();
		this.port = user.getPort();
		this.name = user.getName();
		this.dept = user.getDept();
		this.hp = user.getHP();
		this.logout = user.getLOGOUT();
		this.flag = user.getFlag();
		this.pic = user.getPic();
	}
	
	public User(String id, ArrayList<String> value) {
		this.id = id;
		this.ip = value.get(0);
		if (!value.get(1).equals("")) {
			this.port = Integer.parseInt(value.get(1));
		} else 
			this.port = 0;
		
		this.name = value.get(2);
		this.dept = value.get(3);
		this.hp = value.get(4);
		this.logout = value.get(5);
		this.flag = (value.get(6).equals("true") ? true : false);
		this.pic = value.get(7);
	}
	
	// 게터
	public String 		getID() 				{ return id; 		}
	public String 		getName() 		{ return name;	}
	public String 		getIP() 				{ return ip; 		}
	public int			getPort() 			{ return port; 		}
	public String 		getDept() 			{ return dept;		}
	public String		getHP() 				{ return hp;		}
	public String 		getLOGOUT() 	{ return logout;	}
	public boolean	getFlag() 			{ return flag; 		}
	public String		getPic()				{ return pic;		}
}