// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.data;

import java.util.ArrayList;
import java.util.Hashtable;

public class UserList extends Hashtable <String, ArrayList<String>>{
	
	private static UserList singleton = new UserList();
	
	public static UserList getInstance() {
		if (singleton == null) {
			synchronized (UserList.class) {
				singleton = new UserList();
			}
		}
		return singleton;
	}
	
	private UserList() {}

	public void setAllMember(Hashtable <String, ArrayList<String>> userList) {
		synchronized (UserList.class) {
			this.clear();
			this.putAll(userList);
		}
	}
	
	public void setMember(Hashtable <String, ArrayList<String>> userList) {
		synchronized (UserList.class) {
			this.putAll(userList);
		}
	}
	
	public void removeMember(String id) {
		synchronized (UserList.class) {
			this.remove(id);
		}
	}
}