// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.msg;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import ju.thecompany.android.R;
import ju.thecompany.android.activity.PreferencesActivity;
import ju.thecompany.android.data.User;
import ju.thecompany.android.data.UserList;
import ju.thecompany.android.service.DriveService;
import ju.thecompany.data.DateParser;
import android.app.ListActivity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.LayoutAnimationController;
import android.view.animation.TranslateAnimation;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.CompoundButton.OnCheckedChangeListener;

// 메신저 메인 창
public class MsgMainActivity extends ListActivity{

	// 디버그 프래그
	private static final String DEBUG_TAG = "MsgMainActivity";
    
    // User 어뎁터
    private UserListAdapter mUserListAdapter;
    
    // 부서 어뎁터
    private ArrayList <String> mDeptList = new ArrayList <String>();
    private ArrayAdapter mDeptAdapter;
    private String mCurrentSelectSpin;
    
    
    //위젯
    private CheckBox mCb;
    private ListView mListView;
	
    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.tcmessenger);

        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	

    @Override
    protected void onResume() {
    	super.onResume();

    	if (!PreferencesActivity.getConnection(this)) finish();
    	
    	registerForContextMenu(getListView());
    	
    	IntentFilter filter = new IntentFilter(RECV);
        mReceiver = new MsgMainActivityReceiver();
        registerReceiver(mReceiver, filter);
        filter = new IntentFilter(FINISHRECV);
        mFinishReceiver = new FinishReceiver();
        registerReceiver(mFinishReceiver, filter);
        
        mCb = (CheckBox)findViewById(R.id.tcmeg_chk);
        mCb.setOnCheckedChangeListener(new OnCheckedChangeListener() {

			@Override
			public void onCheckedChanged(CompoundButton buttonView,
					boolean isChecked) {
				
	    		mUserListAdapter = new UserListAdapter(getApplicationContext(), R.layout.tcmessenger_row, convUserList());
	    		setListAdapter(mUserListAdapter);
				
			}});
        
        mCurrentSelectSpin = getText(R.string.tcmessenger_spin_top).toString();

    	mUserListAdapter = new UserListAdapter(this, R.layout.tcmessenger_row, convUserList());

    	setListAdapter(mUserListAdapter);
    	
    	 AnimationSet set = new AnimationSet(true);

         Animation animation = new AlphaAnimation(0.0f, 1.0f);
         animation.setDuration(50);
         set.addAnimation(animation);

         animation = new TranslateAnimation(
             Animation.RELATIVE_TO_SELF, 0.0f,Animation.RELATIVE_TO_SELF, 0.0f,
             Animation.RELATIVE_TO_SELF, -1.0f,Animation.RELATIVE_TO_SELF, 0.0f
         );
         animation.setDuration(100);
         set.addAnimation(animation);

         LayoutAnimationController controller =
                 new LayoutAnimationController(set, 0.5f);
         ListView listView = getListView();        
         listView.setLayoutAnimation(controller);
         
         Spinner s = (Spinner) findViewById(R.id.tcmeg_spinner);
         
         //mDeptAdapter = new ArrayAdapter(this, android.R.layout.simple_spinner_item, mDeptList);
         mDeptAdapter = new ArrayAdapter(this, R.layout.spinner, mDeptList);
         mDeptAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
         s.setAdapter(mDeptAdapter);
         s.setOnItemSelectedListener(new OnItemSelectedListener(){
       
			@Override
			public void onItemSelected(AdapterView parent, View v, int position, long id) {

				mCurrentSelectSpin = (String)parent.getSelectedItem();
				
	    		mUserListAdapter = new UserListAdapter(getApplicationContext(), R.layout.tcmessenger_row, convUserList());
	    		setListAdapter(mUserListAdapter);
				
			}

			@Override
			public void onNothingSelected(AdapterView parent) {
				
				
			}});

        mCb.setChecked(PreferencesActivity.getConBasic(this));
    	//s.setLayoutAnimation(controller);
        mListView = this.getListView();
        mListView.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				User user = mUserListAdapter.getItem(arg2);
				showToastUser(user);
			}});
        
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();
        
    	unregisterReceiver(mReceiver);
    	unregisterReceiver(mFinishReceiver);
    	unregisterForContextMenu(getListView());
    	 
        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝
    
    
    // 콘텍스트메뉴 시작
    public static final int MSGMAIN_ACTIVITY_SEND_CONVERSATION= Menu.FIRST;
    public static final int MSGMAIN_ACTIVITY_SEND_SHORT = Menu.FIRST + 1;
    public static final int MSGMAIN_ACTIVITY_SEND_SMS = Menu.FIRST + 2;
    public static final int MSGMAIN_ACTIVITY_SEND_CALL = Menu.FIRST + 3;
    public static final int MSGMAIN_ACTIVITY_SEND_MAP = Menu.FIRST + 4;
    public static final int MSGMAIN_ACTIVITY_SEND_CLOSE = Menu.FIRST + 5;
    
    @Override
    public void onCreateContextMenu(ContextMenu menu, View view, ContextMenuInfo menuInfo) {
        AdapterView.AdapterContextMenuInfo info;
        try {
             info = (AdapterView.AdapterContextMenuInfo) menuInfo;
        } catch (ClassCastException e) {
            Log.e(DEBUG_TAG, "onCreateContextMenu()", e);
            return;
        }

        User user = (User)getListAdapter().getItem(info.position);
        if (user == null) return;

        menu.setHeaderTitle(user.getName() + "(" + user.getDept() + ")");

        if (user.getFlag())  {
        	menu.add(0, MSGMAIN_ACTIVITY_SEND_CONVERSATION, 0, R.string.tcmessenger_context_conversation);
        	menu.add(0, MSGMAIN_ACTIVITY_SEND_MAP, 4, R.string.tcmessenger_context_map);
        }
        menu.add(0, MSGMAIN_ACTIVITY_SEND_SHORT , 1, R.string.tcmessenger_context_sendshort);
        menu.add(0, MSGMAIN_ACTIVITY_SEND_SMS, 2, R.string.tcmessenger_context_sendmsg);
        menu.add(0, MSGMAIN_ACTIVITY_SEND_CALL, 3, R.string.tcmessenger_context_call);
        
        menu.add(0, MSGMAIN_ACTIVITY_SEND_CLOSE, 5, R.string.tcmessenger_context_close);
    }
        
    @Override
    public boolean onContextItemSelected(MenuItem item) {
        AdapterView.AdapterContextMenuInfo info;
        try {
             info = (AdapterView.AdapterContextMenuInfo) item.getMenuInfo();
        } catch (ClassCastException e) {
        	Log.e(DEBUG_TAG, "onContextItemSelected", e);
            return false;
        }
        
        Intent intent = null;
        
        User user = (User)getListAdapter().getItem(info.position);
        if (user == null) return false;

        switch (item.getItemId()) {
            case MSGMAIN_ACTIVITY_SEND_CONVERSATION:
            	intent = new Intent(DriveService.RECV);
    			intent.putExtra("activity", DriveService.SEND_ACTIVITY_MSGMAIN);
    			intent.putExtra("mode", MSGMAIN_ACTIVITY_SEND_CONVERSATION);
    			intent.putExtra("object", user);
    			sendBroadcast(intent);	
                return true;
            case MSGMAIN_ACTIVITY_SEND_SHORT:
            	intent = new Intent(DriveService.RECV);
    			intent.putExtra("activity", DriveService.SEND_ACTIVITY_MSGMAIN);
    			intent.putExtra("mode", MSGMAIN_ACTIVITY_SEND_SHORT);
    			intent.putExtra("object", user);
    			sendBroadcast(intent);	
                return true;
            case MSGMAIN_ACTIVITY_SEND_SMS:
            	intent = new Intent(DriveService.RECV);
    			intent.putExtra("activity", DriveService.SEND_ACTIVITY_MSGMAIN);
    			intent.putExtra("mode", MSGMAIN_ACTIVITY_SEND_SMS);
    			intent.putExtra("object", user);
    			sendBroadcast(intent);	
            	return true;
            case MSGMAIN_ACTIVITY_SEND_CALL:
            	intent = new Intent(DriveService.RECV);
    			intent.putExtra("activity", DriveService.SEND_ACTIVITY_MSGMAIN);
    			intent.putExtra("mode", MSGMAIN_ACTIVITY_SEND_CALL);
    			intent.putExtra("object", user);
    			sendBroadcast(intent);	
                return true;
            case MSGMAIN_ACTIVITY_SEND_MAP:
            	intent = new Intent(DriveService.RECV);
    			intent.putExtra("activity", DriveService.SEND_ACTIVITY_MSGMAIN);
    			intent.putExtra("mode", MSGMAIN_ACTIVITY_SEND_MAP);
    			intent.putExtra("object", user);
    			sendBroadcast(intent);	
                return true;
            case MSGMAIN_ACTIVITY_SEND_CLOSE: 
                return true;
        }
        return false;
    }
    // 콘텍스트메뉴 끝
	
    
	// 내부 메쏘드
    private ArrayList<User> convUserList() {
    	
    	mDeptList.clear();
    	ArrayList<User> al = new ArrayList<User>();
    	User user;
    	Vector <String> v = new Vector<String>(UserList.getInstance().keySet());
    	Collections.sort(v);

    	Iterator <String> it = v.iterator();
    	while (it.hasNext()) {
    		String id =  it.next();
    		if (PreferencesActivity.getUserLast(MsgMainActivity.this).equals(id))
    			continue;
    		user = new User(id, UserList.getInstance().get(id));
    		if (mCurrentSelectSpin.equals(getText(R.string.tcmessenger_spin_top)) || mCurrentSelectSpin.equals(user.getDept())) {
    			if (mCb.isChecked()) {
    				if (user.getFlag()) al.add(user);
    			} else {
    				al.add(user);
    			}
    		}
    		if (!mDeptList.contains(user.getDept())) {
    			if (mCb.isChecked()) {
    				if (user.getFlag()) mDeptList.add(user.getDept());
    			}
    			else {
    				mDeptList.add(user.getDept());
    			}
    			
    		}
    	}
    	
    	Collections.sort(mDeptList);
    	mDeptList.add(0, getText(R.string.tcmessenger_spin_top).toString());
    	return al;
    }
    
    // 리시버 시작
    private static final String FINISHRECV = "ju.thecompany.android.FINISH";
    private FinishReceiver mFinishReceiver;

    private class FinishReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {

			finish();
   			//
	        Log.d(DEBUG_TAG, "finishReceiver()");
	        //
		}
    }
    
    public static final String RECV = "ju.thecompany.android.msg.MSGMAINACTIVITYRECEIVER";
    MsgMainActivityReceiver mReceiver;
	Intent mRecvIntent; 
	
	
	public static final int MSGMAIN_ACTIVITY_RECV_USER_ADD = 0;
	public static final int MSGMAIN_ACTIVITY_RECV_USER_DEL = 1;

    public class MsgMainActivityReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {
			
			mRecvIntent = intent;
			
			Thread threadProcessReceiver = new Thread(null, processReceiverThread, "Background" );
			threadProcessReceiver.start();
   			//
	        Log.d(DEBUG_TAG, "onReceive()");
	        //
		}
    }
    
    private Runnable processReceiverThread = new Runnable() {

		@Override
		public void run() {

	        handler.post(processReceiver);
		}
    	
    };
    
    private Runnable processReceiver = new Runnable() {
    	
		@Override
		public void run() {

			processReceiver();
		}
    	
    };
    
    private void processReceiver() {
    	
    	int mode = mRecvIntent.getIntExtra("mode", 0);
    	Object obj = mRecvIntent.getSerializableExtra("object");
    	switch (mode) {
    	case MSGMAIN_ACTIVITY_RECV_USER_ADD :
    		mUserListAdapter = new UserListAdapter(this, R.layout.tcmessenger_row, convUserList());
    		setListAdapter(mUserListAdapter);
    		showToastUserState(obj, true);
    		break;
    	case MSGMAIN_ACTIVITY_RECV_USER_DEL :
    		mUserListAdapter = new UserListAdapter(this, R.layout.tcmessenger_row, convUserList());
    		setListAdapter(mUserListAdapter);
    		showToastUserState(obj, false);
    		break;
    	}
    }
    
    private void showToastUserState(Object obj, boolean flag) {

    	User user = (User)obj;
    	
    	Toast toast = new Toast(getApplicationContext());
    	
    	LayoutInflater Li = LayoutInflater.from(getApplicationContext());
		View v = Li.inflate(R.layout.user_alert_toast, null);
		
		TextView msgTextView = (TextView) v.findViewById(R.id.user_toast_msg);
		TextView timeTextView = (TextView) v.findViewById(R.id.user_toast_time);
		ImageView picImageView = (ImageView) v.findViewById(R.id.user_toast_pic);
    	
		if (picImageView != null) {
			if (!user.getPic().equals("")) 
				picImageView.setImageBitmap(BitmapFactory.decodeFile("/sdcard/" + user.getPic()));
			else
				picImageView.setImageResource(android.R.drawable.ic_menu_camera);
		}
		long time = System.currentTimeMillis();
		Date systemTime = new Date();
		systemTime.setTime(time);
		timeTextView.setText("부서 : " + user.getDept() + " (" + DateParser.dateToString(systemTime)+ ") ");
		toast.setDuration(Toast.LENGTH_LONG);
    	if (flag) {
    		msgTextView.setText(user.getName() + "님이 입장하셨습니다.");
    		toast.setView(v);
    		toast.show();
    	} else {
    		msgTextView.setText(user.getName() + "님이 퇴장하셨습니다.");
    		toast.setView(v);
    		toast.show();
    	}
    	
    }
    
    private void showToastUser(User user) {

    	Toast toast = new Toast(getApplicationContext());
    	toast.setDuration(Toast.LENGTH_LONG);
    	
    	LayoutInflater Li = LayoutInflater.from(getApplicationContext());
		View v = Li.inflate(R.layout.user_info_toast, null);
		
		TextView idTextView = (TextView) v.findViewById(R.id.user_info_id);
		TextView nameTextView = (TextView) v.findViewById(R.id.user_info_name);
		TextView deptTextView = (TextView) v.findViewById(R.id.user_info_dept);
		TextView hpTextView = (TextView) v.findViewById(R.id.user_info_hp);
		TextView logoutTextView = (TextView) v.findViewById(R.id.user_info_logout);
		ImageView picImageView = (ImageView) v.findViewById(R.id.user_info_pic);
    	
		if (picImageView != null) {
			if (!user.getPic().equals("")) 
				picImageView.setImageBitmap(BitmapFactory.decodeFile("/sdcard/" + user.getPic()));
			else
				picImageView.setImageResource(android.R.drawable.ic_menu_camera);
		}
		
		idTextView.setText("ID : " + user.getID());
		nameTextView.setText("Name : " + user.getName());
		deptTextView.setText("부서 : " + user.getDept());
		hpTextView.setText("HP : " + user.getHP());
		if (user.getFlag())  logoutTextView.setText("Logout : 접속중");
		else logoutTextView.setText("Logout : " + user.getLOGOUT());

    	toast.setView(v);
    	toast.show();

    }
    
    
    // 리시버 끝
    
    // 어뎁터
    public class UserListAdapter extends ArrayAdapter<User>{

    	private ArrayList<User> items;
    	
    	public UserListAdapter(Context context, int textViewResourceId,
    			ArrayList<User> items) {
    		super(context, textViewResourceId, items);
    		
    		this.items = items;
    		
    	}
     
    	@Override
    	public View getView(int position, View convertView, ViewGroup parent) {
    		View v = convertView;
    		
    		if (v == null) {
    			LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    			v = vi.inflate(R.layout.tcmessenger_row, null);
    		}
    		
			TextView nameTextView = (TextView) v.findViewById(R.id.tcmessenger_name);
			TextView idTextView = (TextView) v.findViewById(R.id.tcmessenger_id_login);
			TextView hpTextView = (TextView) v.findViewById(R.id.tcmessenger_dept_hp);
			ImageView picImageView = (ImageView) v.findViewById(R.id.tcmessenger_pic);



    		User user = items.get(position);

    		if (user != null) {

    			// 데이타 입력
    			if (picImageView != null) {
					if (!user.getPic().equals("")) 
						picImageView.setImageBitmap(BitmapFactory.decodeFile("/sdcard/" + user.getPic()));
					else
						picImageView.setImageResource(android.R.drawable.ic_menu_camera);
    			}
    			if (nameTextView != null){
    				nameTextView.setText(user.getName());
    			}

    			if (idTextView != null){
    				idTextView.setText(user.getID() + "[" + user.getDept() + "]");
    			}
    			
    			if (hpTextView != null){
    				hpTextView.setText(getText(R.string.tcmessenger_hp) + " : " + user.getHP());
    			}
    			
    			if (!user.getFlag()) {
    				nameTextView.setEnabled(false);
    				idTextView.setEnabled(false);
    				hpTextView.setEnabled(false);
    				picImageView.setEnabled(false);
    				picImageView.setAlpha(80);
    				v.setEnabled(false); 
    			}
    			else  {
    				nameTextView.setEnabled(true);
    				idTextView.setEnabled(true);
    				hpTextView.setEnabled(true);
    				picImageView.setEnabled(true);
    				picImageView.setAlpha(255);
    				v.setEnabled(true); 
    			}
       			//
    	        Log.d(DEBUG_TAG, user.getID() +  " : " + (user.getFlag() ? "TRUE" : "FALSE"));
    	        //
    		}
    		return v;
    	}
    }
    // 어뎁터 끝
    
    // 핸들러
    private Handler handler = new Handler();
    
    
}
