// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.noticeshort;

import ju.thecompany.android.R;
import ju.thecompany.android.data.UserNoticeShort;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

// 공지 알림 다이알로
public class NoticeActivity extends Activity{

	// 디버그 프래그
	private static final String DEBUG_TAG = "NoticeActivity";
	
	// 노티파이
	private NotificationManager mNM;
	
	// 다이얼로그
	private static final int DIALOG_NOTICE = 0;
	
	// 메시지
	private String mTitle = "";
	private String mContents = "";
	
    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	
    @Override
    protected void onResume() {
    	super.onResume();
    	
    	UserNoticeShort userNoticeShort = (UserNoticeShort)getIntent().getSerializableExtra("object");
    	mTitle = userNoticeShort.getTitle();
    	mContents = userNoticeShort.getText();
    	
    	mNM = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);

    	showDialog(DIALOG_NOTICE);
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();

        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝
    
    // 다이얼로그
    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {

        case DIALOG_NOTICE:
            return new AlertDialog.Builder(NoticeActivity.this)
                .setIcon(android.R.drawable.ic_dialog_info)
                .setTitle(mTitle)
                .setMessage(mContents)
                .setCancelable(false)
                .setPositiveButton(R.string.notice_ok, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                    	showNotification();
                    	finishApp();
                    }
                })
                .create();
        }
        return null;
    }
    
    // 내부메소드 시작
	private void finishApp() {
		finish();
	}
	
    private void showNotification() {
    	
    	UserNoticeShort userNoticeShort = (UserNoticeShort)getIntent().getSerializableExtra("object");

        CharSequence text = userNoticeShort.getTitle();

        Notification notification = new Notification(R.drawable.stat_sample, text,
                System.currentTimeMillis());

        PendingIntent contentIntent = PendingIntent.getActivity(this, 0,
                new Intent(this, ShortNoticeActivity.class), 0);

        notification.setLatestEventInfo(this, getText(R.string.shortmsg_nofity),
                       text, contentIntent);

        mNM.notify(R.string.shortmsg_nofity, notification);
    }
}