// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.noticeshort;

import java.util.ArrayList;
import java.util.Vector;

import ju.thecompany.android.R;
import ju.thecompany.android.data.User;
import ju.thecompany.android.data.UserNoticeShort;
import ju.thecompany.android.db.DBAdapterIF;
import ju.thecompany.android.db.NoticeMsgDBAdapter;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.CompoundButton.OnCheckedChangeListener;

// 공지 리스트 화면
public class NoticeListActivity extends ListActivity {
	
	// 디버그 프래그
	private static final String DEBUG_TAG = "NoticeListActivity";

	// UserNoticeShort 어뎁터
    private NoticeShortAdapter mNoticeShortAdapter;
    
    // 체크
    private Vector <Boolean>mChkData;
    private Vector <Integer>mDbKey;
    
    // 옵션메뉴
    private Menu mMenu;
    
    // DB
    DBAdapterIF mDba;

    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.msgbox_short);
        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	

    @Override
    protected void onResume() {
    	super.onResume();

    	// 콘텍스트 메뉴 등록
    	registerForContextMenu(getListView());
    	
    	// SQLite3 에서 데이터를 가져와 어뎁터에 등록한다.
    	ArrayList <UserNoticeShort> al = new ArrayList<UserNoticeShort>();
    	mDbKey = new Vector<Integer>();
    	mDba = new NoticeMsgDBAdapter(this);
    	mDba.open();
    	Cursor cursor = mDba.getAllUserNoticeShortCursor();
    	
    	if (cursor.moveToFirst()) {
    		do {
    			ArrayList <String> tempAL = new ArrayList <String>(8);
    			tempAL.add(0, "");
    			tempAL.add(1, "");
    			tempAL.add(2, cursor.getString(NoticeMsgDBAdapter.COLUMN_NAME));
    			tempAL.add(3, cursor.getString(NoticeMsgDBAdapter.COLUMN_DEPT));
    			tempAL.add(4, cursor.getString(NoticeMsgDBAdapter.COLUMN_HP));
    			tempAL.add(5, "");
    			tempAL.add(6, "");
    			tempAL.add(7, "");
    			
    			UserNoticeShort uns = new UserNoticeShort(new User(cursor.getString(NoticeMsgDBAdapter.COLUMN_ID), tempAL), 
    					cursor.getString(NoticeMsgDBAdapter.COLUMN_DATE), cursor.getString(NoticeMsgDBAdapter.COLUMN_TITLE), 
    					cursor.getString(NoticeMsgDBAdapter.COLUMN_CONTENTS));
    			al.add(uns);
    			// 가변 키를 받아와 저정한다(삭제에 이용)
    			mDbKey.add(cursor.getInt(NoticeMsgDBAdapter.COLUMN_ORDER));
    		} while (cursor.moveToNext());
    	}

    	mNoticeShortAdapter = new NoticeShortAdapter(this, R.layout.msgbox_short_row, al);
    	setListAdapter(mNoticeShortAdapter);
    	
    	mDba.close();
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();

    	unregisterForContextMenu(getListView());
        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝
    
    // 콘텍스트메뉴
    // 콘텍스트메뉴 시작
    public static final int MENU_CONTEXT_REMOVE = Menu.FIRST;
    public static final int MENU_CONTEXT_CLOSE = Menu.FIRST + 1;
    
    @Override
    public void onCreateContextMenu(ContextMenu menu, View view, ContextMenuInfo menuInfo) {
        AdapterView.AdapterContextMenuInfo info;
        try {
             info = (AdapterView.AdapterContextMenuInfo) menuInfo;
        } catch (ClassCastException e) {
            Log.e(DEBUG_TAG, "onCreateContextMenu()", e);
            return;
        }
        

        UserNoticeShort userNoticeShort = (UserNoticeShort)getListAdapter().getItem(info.position);
        if (userNoticeShort == null) return;

        menu.setHeaderTitle(userNoticeShort.getTitle());

        menu.add(0, MENU_CONTEXT_REMOVE , 0, R.string.shortnotice_context_remove);
        menu.add(0, MENU_CONTEXT_CLOSE , 1, R.string.shortnotice_context_close);

    }
        
    @Override
    public boolean onContextItemSelected(MenuItem item) {
        AdapterView.AdapterContextMenuInfo info;
        try {
             info = (AdapterView.AdapterContextMenuInfo) item.getMenuInfo();
        } catch (ClassCastException e) {
        	Log.e(DEBUG_TAG, "onContextItemSelected", e);
            return false;
        }
        
        Intent intent = null;
        
        UserNoticeShort userNoticeShort = (UserNoticeShort)getListAdapter().getItem(info.position);
        if (userNoticeShort == null) return false;

        switch (item.getItemId()) {
        	case MENU_CONTEXT_REMOVE: 
        		mDba.open();
        		mDba.removeMsg(mDbKey.get(info.position));
        		mDbKey.remove(info.position);
        		mChkData.remove(info.position);
        		mNoticeShortAdapter.remove(userNoticeShort);
        		
        		for (int i =0 ; i < mChkData.size() ; ) {
        			if (mChkData.get(i)) {
        				mChkData.remove(i);
        				mDba.removeMsg(mDbKey.get(i));
        				mDbKey.remove(i);
    					mNoticeShortAdapter.remove(mNoticeShortAdapter.getItem(i));	
        			}
        			else i++;
        		}
        		mDba.close();
        		return true;
            case MENU_CONTEXT_CLOSE: 
                return true;
        }
        return false;
    }
    // 콘텍스트메뉴 끝
    
    // 옵션메뉴
    public static final int MENU_OPTION_REMOVE = Menu.FIRST;
    public static final int MENU_OPTION_REMOVE_ALL = Menu.FIRST + 1;
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        mMenu = menu;
        
        menu.add(0, MENU_OPTION_REMOVE  , 0, R.string.shortnotice_menu_remove).setIcon(android.R.drawable.ic_menu_agenda);
        menu.add(0, MENU_OPTION_REMOVE_ALL  , 1, R.string.shortnotice_menu_remove_all).setIcon(android.R.drawable.ic_menu_close_clear_cancel);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case MENU_OPTION_REMOVE:
        	mDba.open();
    		for (int i =0 ; i < mChkData.size() ; ) {
    			if (mChkData.get(i)) {
    				mChkData.remove(i);
    				mDba.removeMsg(mDbKey.get(i));
    				mDbKey.remove(i);
					mNoticeShortAdapter.remove(mNoticeShortAdapter.getItem(i));	
    			}
    			else i++;
    		}
    		mDba.close();
        	return true;
        case MENU_OPTION_REMOVE_ALL:
        	mDba.open();
    		for (int i =0 ; i < mChkData.size() ; ) {
    				mChkData.remove(i);
    				mDba.removeMsg(mDbKey.get(i));
    				mDbKey.remove(i);
					mNoticeShortAdapter.remove(mNoticeShortAdapter.getItem(i));	
    		}
    		mDba.close();
        	return true;
        }
        
        return false;
    }
	    


    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) 
    {    
    	 ((NoticeShortAdapter)getListAdapter()).toggle(position);
    }
    
    //어뎁터
    public class NoticeShortAdapter extends ArrayAdapter<UserNoticeShort>{

    	private ArrayList<UserNoticeShort> items;
    	
    	public NoticeShortAdapter(Context context, int textViewResourceId,
    			ArrayList<UserNoticeShort> items) {
    		super(context, textViewResourceId, items);
    		
    		this.items = items;
    		toggleData = new Vector<Boolean>(items.size());
    		mChkData = new Vector<Boolean>(items.size());
    		for (int i = 0; i < items.size(); i++) {
    			toggleData.add(false);
    			mChkData.add(false);
    			
    		}
    	}
    	
    	@Override
    	public View getView(int position, View convertView, ViewGroup parent) {
    		View v = convertView;
    		
    		if (v == null) {
    			LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    			v = vi.inflate(R.layout.msgbox_short_row, null);
    		}
    		final int pos = position;
    		
			TextView sendUserTextView = (TextView) v.findViewById(R.id.msgbox_short_list_row_senduser);
			TextView contentsTextView = (TextView) v.findViewById(R.id.msgbox_short_list_row_contents);
			TextView dateTextView = (TextView) v.findViewById(R.id.msgbox_short_list_row_date);
			TextView titleTextView = (TextView) v.findViewById(R.id.msgbox_short_list_row_title);
			CheckBox chkCheckBox = (CheckBox) v.findViewById(R.id.msgbox_short_list_row_checkbox);
			
    		chkCheckBox.setOnCheckedChangeListener(new OnCheckedChangeListener() {

				@Override
				public void onCheckedChanged(CompoundButton buttonView,
						boolean isChecked) {
					mChkData.remove(pos);
					mChkData.add(pos, isChecked );
			        //
			        Log.d(DEBUG_TAG, "check " + pos);
			        //
				}});
			
			UserNoticeShort userNoticiShort = items.get(position);

    		if (userNoticiShort != null) {

    			// 데이타 입력
    			if (sendUserTextView != null){
    				sendUserTextView.setText("From : " + userNoticiShort.getName() + "(" + userNoticiShort.getID() + ":" +userNoticiShort.getDept()+ ")");
    			}
    			if (dateTextView != null){
    				dateTextView.setText(userNoticiShort.getDate());
    			}
    			if (contentsTextView != null){
    				if (toggleData.get(position)) {
    					contentsTextView.setVisibility(View.VISIBLE);
    					contentsTextView.setText(userNoticiShort.getText());
    				}
    				else contentsTextView.setVisibility(View.GONE);
    				
    			}

    			if (titleTextView != null){
    				if (toggleData.get(position)) {
    					titleTextView.setSingleLine(false);
    					titleTextView.setText(userNoticiShort.getTitle());
    				}
    				else {
    					titleTextView.setSingleLine(true);
    					titleTextView.setText(userNoticiShort.getTitle());
    				}
    			}
    			
    			if (mChkData.get(position))
    				chkCheckBox.setChecked(true);
    			else chkCheckBox.setChecked(false);

    			
    		}
    		return v;
    	}
    	
    	// 토글 액션을 위해 부울값 변경
        public void toggle(int position) {
        	boolean flag = toggleData.get(position);
        	toggleData.remove(position);
        	toggleData.add(position, !flag);
            notifyDataSetChanged();
        }
        
        private Vector <Boolean>toggleData;
    }
    // 어뎁터 끝
}