// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.noticeshort;


import ju.thecompany.android.R;
import ju.thecompany.android.data.UserNoticeShort;
import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

public class ShortMsgActivity extends Activity{

	// 디버그 프래그
	private static final String DEBUG_TAG = "ShortMsgActivity";
	
	// 노티파이
	private NotificationManager mNM;
	
	// 인텐트
	private Intent mIntent;
	
    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	
    @Override
    protected void onResume() {
    	super.onResume();
    	
    	mIntent = getIntent();
    	
    	mNM = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);
    	showNotification();

    	showToast();
    	finish();
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();

        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝
    
	// 토스트 실행 
	public void showToast() {
		/*
		UserNoticeShort userNoticeShort = (UserNoticeShort)mIntent.getSerializableExtra("object");
		
		LayoutInflater inflater = getLayoutInflater();
		View layout = inflater.inflate(R.layout.toast_layout,
		                               (ViewGroup) findViewById(R.id.toast_layout_root));

		ImageView image = (ImageView) layout.findViewById(R.id.toast_image);
		image.setImageResource(android.R.drawable.ic_dialog_alert);
		TextView text = (TextView) layout.findViewById(R.id.toast_text);
		text.setText(userNoticeShort.getTitle() + ":" + userNoticeShort.getText());
		Toast toast = new Toast(getApplicationContext());
		toast.setGravity(Gravity.CENTER_VERTICAL, 0, 0);
		toast.setDuration(Toast.LENGTH_LONG);
		toast.setView(layout);
		toast.show();
		*/
		Toast.makeText(this.getApplicationContext(), R.string.shortmsg_nofity, Toast.LENGTH_SHORT).show();
	}
	
    private void showNotification() {
    	
    	UserNoticeShort userNoticeShort = (UserNoticeShort)mIntent.getSerializableExtra("object");

        CharSequence text = userNoticeShort.getTitle();

        Notification notification = new Notification(R.drawable.stat_sample, text,
                System.currentTimeMillis());

        PendingIntent contentIntent = PendingIntent.getActivity(this, 0,
                new Intent(this, ShortNoticeActivity.class), 0);

        notification.setLatestEventInfo(this, getText(R.string.shortmsg_nofity),
                       text, contentIntent);

        mNM.notify(R.string.shortmsg_nofity, notification);
    }
}