// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.noticeshort;

import java.util.Date;

import ju.thecompany.android.R;
import ju.thecompany.android.activity.PreferencesActivity;
import ju.thecompany.android.data.User;
import ju.thecompany.android.data.UserList;
import ju.thecompany.android.data.UserNoticeShort;
import ju.thecompany.android.service.DriveService;
import ju.thecompany.data.DateParser;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

// 쪽지 쓰기 화면
public class ShortMsgWriteActivity extends Activity {

	// 디버그 프래그
	private static final String DEBUG_TAG = "ShortMsgWriteActivity";
	
	// 위젯
	private TextView mToTextBox;
	private TextView mToDescTextBox;
	private TextView mLenghTextBox;
	private EditText mTitleEditText;
	private EditText mContentsEditText;
	private Button mSendButton;
	private Button mCancleButton;
	
	// 대화유저
	private User mUserMe;
	private User mUserYou;
	
	
	//구분자
    private static final String SEPT = "/!`/~";
	
    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.shortmsg_write);
        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	
    @Override
    protected void onResume() {
    	super.onResume();
    	
    	IntentFilter filter = new IntentFilter(FINISHRECV);
        mFinishReceiver = new FinishReceiver();
        registerReceiver(mFinishReceiver, filter);

    	mToTextBox = (TextView)findViewById(R.id.shortmsg_writer_to);
    	mToDescTextBox = (TextView)findViewById(R.id.shortmsg_writer_to_desc);
    	mLenghTextBox = (TextView)findViewById(R.id.shortmsg_writer_length);
    	mTitleEditText = (EditText)findViewById(R.id.shortmsg_writer_title);
    	mContentsEditText = (EditText)findViewById(R.id.shortmsg_writer_contents);
    	mSendButton = (Button)findViewById(R.id.shortmsg_writer_send);
    	mCancleButton = (Button)findViewById(R.id.shortmsg_writer_cancle);
    	
        String id = PreferencesActivity.getUserLast(this);
        mUserMe = new User(id, UserList.getInstance().get(id));
        mUserYou = (User)getIntent().getSerializableExtra("object");
        
        mToTextBox.setText(mUserYou.getName() );
        mToDescTextBox.setText(mUserYou.getID() + ":" + mUserYou.getDept() + ":" + (mUserYou.getFlag() ? "로그인중" : "접속종료"));  
        
        mContentsEditText.setOnKeyListener(new OnKeyListener(){

			@Override
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				mLenghTextBox.setText("" + mContentsEditText.getText().length() + "/200");
				return false;
			}});
        
        mSendButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if (!mContentsEditText.getText().toString().trim().equals(""))  {
					if (mTitleEditText.getText().toString().trim().equals(""))
						if (mContentsEditText.getText().toString().length() > 15) 
							mTitleEditText.setText(mContentsEditText.getText().toString().substring(0, 14) + "...");
						else 
							mTitleEditText.setText(mContentsEditText.getText().toString());
					sendMsg();
					finishApp();
				}
				else {
					mContentsEditText.setHint(R.string.shortmsg_write_hint);
				}
			}});
        
        mCancleButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finishApp();
				
			}});
        
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();

    	unregisterReceiver(mFinishReceiver);
        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝
    
    // 내부메소드 시작

    private void finishApp() {
    	
    	finish();
    }
    
    private void sendMsg() {
    	
		long time = System.currentTimeMillis();
		Date systemTime = new Date();
		systemTime.setTime(time);
		
    	UserNoticeShort uns = new UserNoticeShort(mUserYou, DateParser.dateToString(systemTime) ,  mTitleEditText.getText().toString(), mContentsEditText.getText().toString());
    	Intent intent = new Intent();
		intent.setAction(DriveService.RECV);
		intent.putExtra("activity", DriveService.SEND_ACTIVITY_SHORTMSGWRITE);
		intent.putExtra("object", uns);
		sendBroadcast(intent);
		
		Toast.makeText(getApplicationContext(), R.string.short_send_ok, Toast.LENGTH_SHORT).show();
    }
    // 내부메소드 끝
    
    // 리시버 시작
    private static final String FINISHRECV = "ju.thecompany.android.FINISH";
    private FinishReceiver mFinishReceiver;

    private class FinishReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {

			finish();
   			//
	        Log.d(DEBUG_TAG, "finishReceiver()");
	        //
		}
    }
}
