// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.android.noticeshort;

import ju.thecompany.android.R;

import android.app.NotificationManager;
import android.app.TabActivity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Menu;
import android.widget.TabHost;

// 쪽지, 공지 탭 화면
public class ShortNoticeActivity extends TabActivity {

	// 디버그 프래그
	private static final String DEBUG_TAG = "ShortNoticeActivity";
	
	// 위젯
	private Menu mMenu;

	
    // 라이프싸이클 메쏘드 시작
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

        //
        Log.d(DEBUG_TAG, "onCreate()");
        //
	}
	

    @Override
    protected void onResume() {
    	super.onResume();

    	NotificationManager nm = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);
    	nm.cancel(R.string.shortmsg_nofity);
    	
    	IntentFilter filter = new IntentFilter(RECV);
        mReceiver = new  ShortNoticeActivityReceiver();
        registerReceiver(mReceiver, filter);
        
        final TabHost tabHost = getTabHost();

        // 텝에 쪽지, 공지 리스트 등록
        tabHost.addTab(tabHost.newTabSpec("tab1")
                .setIndicator(getText(R.string.shortmsg_title).toString(), getResources().getDrawable(android.R.drawable.ic_dialog_email))
                .setContent(new Intent(this, ShortMsgListActivity.class)));

        
        tabHost.addTab(tabHost.newTabSpec("tab2")
                .setIndicator(getText(R.string.notice_title).toString(), getResources().getDrawable(android.R.drawable.ic_dialog_info))
                .setContent(new Intent(this, NoticeListActivity.class)));
        
        //
        Log.d(DEBUG_TAG, "onResume()");
        //
    }
    
    protected void onPause() {
    	super.onPause();
        
    	unregisterReceiver(mReceiver);
    	
        //
        Log.d(DEBUG_TAG, "onPause()");
        //
    }
    // 라이프싸이클 메쏘드 끝

    
    // 내부메소드 시작
	private void finishApp() {
		finish();
	}
	// 내부메소드 끝

    
    // 리시버 시작
    
    public static final String RECV = "ju.thecompany.android.msg.SHORTNOTICEACTIVITY";
    private ShortNoticeActivityReceiver mReceiver;
	private Intent mRecvIntent; 

    public class ShortNoticeActivityReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {
			
			mRecvIntent = intent;
			
			Thread threadProcessReceiver = new Thread(null, processReceiverThread, "Background" );
			threadProcessReceiver.start();
   			//
	        Log.d(DEBUG_TAG, "onReceive()");
	        //
		}
    }
    
    private Runnable processReceiverThread = new Runnable() {

		@Override
		public void run() {

	        handler.post(processReceiver);
		}
    	
    };
    
    private Runnable processReceiver = new Runnable() {
    	
		@Override
		public void run() {

			processReceiver();
		}
    	
    };
    
    private void processReceiver() {
  
    }
 
    // 리시버 끝
 
    // 핸들러
    private Handler handler = new Handler();

}
