package ju.thecompany.data;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;


import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


public class TCXMLParser {
	public static String parseString(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj) {

		String result = "";
		
		result += "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>";
		result += "<document key=\"code\" value=\""+ sendToken.code + "\">";
		result += "<category key=\"datatype\" value=\"userdata\" flag=\"\" >";
		result += "<item>";
		result += "<element key=\"id\" value=\"" +sendToken.id + "\"/>";
		result += "<element key=\"ip\" value=\"" +sendToken.ip + "\"/>";
		result += "<element key=\"port\" value=\"" +sendToken.port + "\"/>";
		result += "<element key=\"date\" value=\"" +sendToken.date + "\"/>";
		result += "</item>";
		result += "</category>";
		
		result += "<category key=\"datatype\" value=\"targetuserdata\" flag=\"\" >";
		result += "<item>";
		result += "<element key=\"id\" value=\"" +recvToken.id + "\"/>";
		result += "<element key=\"ip\" value=\"" +recvToken.ip + "\"/>";
		result += "<element key=\"port\" value=\"" +recvToken.port + "\"/>";
		result += "</item>";
		result += "</category>";
		
		result += "<category key=\"datatype\" value=\"userdata\" flag=\"";
		
		 if (obj instanceof Hashtable<?, ?> ) {
			 result += "hash\">";
			 Hashtable <String, ArrayList <String>> ht = (Hashtable <String, ArrayList<String>>)obj;
			 
			 Enumeration<String> e = ht.keys();
			 
			 if ( e != null) {
				 
				 while(e.hasMoreElements()) {
					result += "<item>";
					String id = e.nextElement();
					ArrayList <String> al = ht.get(id);
					
					result += "<element key=\"id\" value=\"" + id + "\"/>";
					result += "<element key=\"ip\" value=\"" + al.get(0) + "\"/>";
					result += "<element key=\"port\" value=\"" + al.get(1) + "\"/>";
					result += "<element key=\"name\" value=\"" + al.get(2) + "\"/>";
					result += "<element key=\"dept\" value=\"" + al.get(3) + "\"/>";
					result += "<element key=\"hp\" value=\"" + al.get(4) + "\"/>";
					result += "<element key=\"logoutdate\" value=\"" + al.get(5) + "\"/>";
					result += "<element key=\"flag\" value=\"" + al.get(6) + "\"/>";
					result += "<element key=\"pic\" value=\"" + al.get(7) + "\"/>";
					
					result += "</item>";
				 }
			 }
			 result += "</category>";
		 }
		if (obj instanceof String ) {
			result += "text\">";
			result += "<item>";
			result += "<element key=\"text\" value=\"" + (String)obj + "\"/>";
			result += "</item>";
			result += "</category>";
		}
		if (obj == null) {
			result += "empty\">";
			result += "<item>";
			result += "</item>";
			result += "</category>";
		}

		result += "</document>";
		
		return result;
	}

	public static Object parseData(TheCompanyDataToken emptySendToken, TheCompanyDataToken emptyRecvToken, String xmlString) throws ParserConfigurationException, SAXException, IOException {
		
		Object result = null;
	
		InputStream is = new ByteArrayInputStream(xmlString.getBytes("UTF-8"));
		DocumentBuilder documentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		Document doc = documentBuilder.parse(is);
		
		NodeList docList = doc.getChildNodes();

		NamedNodeMap namedNode = docList.item(0).getAttributes();
		String key = namedNode.getNamedItem("key").getNodeValue();
		emptySendToken.code = Integer.parseInt(namedNode.getNamedItem("value").getNodeValue());
		docList = docList.item(0).getChildNodes();
		for(int i =0; i < docList.getLength() ; i++) {
			namedNode = docList.item(i).getAttributes();
			key = namedNode.getNamedItem("key").getNodeValue();
			String flag = namedNode.getNamedItem("flag").getNodeValue();
			String value = namedNode.getNamedItem("value").getNodeValue();
			if ( value.equals("userdata") && ( flag.equals("")) ) {
				Node dataNode = docList.item(i).getFirstChild();
				NodeList categoryList = dataNode.getChildNodes();
				for (int j = 0; j < categoryList.getLength(); j++) {
					NamedNodeMap usermap = categoryList.item(j).getAttributes();
					key = usermap.getNamedItem("key").getNodeValue();
					value = usermap.getNamedItem("value").getNodeValue();
					if (key.equals("id")) emptySendToken.id = value;
					if (key.equals("ip")) emptySendToken.ip = value;
					if (key.equals("port")) emptySendToken.port = Integer.parseInt(value);
					if (key.equals("date")) emptySendToken.date = value;
				}
			}
			if ( value.equals("targetuserdata") && ( flag.equals("")) ) {
				Node dataNode = docList.item(i).getFirstChild();
				NodeList categoryList = dataNode.getChildNodes();
				for (int j = 0; j < categoryList.getLength(); j++) {
					NamedNodeMap usermap = categoryList.item(j).getAttributes();
					key = usermap.getNamedItem("key").getNodeValue();
					value = usermap.getNamedItem("value").getNodeValue();
					if (key.equals("id")) emptyRecvToken.id = value;
				}
			}
			if ( value.equals("userdata") && ( flag.equals("hash")) ) {
				
				NodeList itemList =  docList.item(i).getChildNodes();
				Hashtable <String, ArrayList<String>> ht = new Hashtable <String, ArrayList<String>>();
				for (int j = 0; j < itemList.getLength(); j++) {
					NodeList elementList = itemList.item(j).getChildNodes();
					String id = null;
					ArrayList <String> al = new ArrayList <String> (8);
					for (int k = 0; k < elementList.getLength(); k++) {
						NamedNodeMap usermap = elementList.item(k).getAttributes();
						key = usermap.getNamedItem("key").getNodeValue();
						value = usermap.getNamedItem("value").getNodeValue();
						if (key.equals("id")) id = value;
						if (key.equals("ip")) al.add(0, value);
						if (key.equals("port")) al.add(1, value);
						if (key.equals("name")) al.add(2, value);
						if (key.equals("dept")) al.add(3, value);
						if (key.equals("hp")) al.add(4, value);
						if (key.equals("logoutdate")) al.add(5, value);
						if (key.equals("flag")) al.add(6, value);
						if (key.equals("pic")) al.add(7, value);
					}
					ht.put(id, al);
				}
				result = ht;
			}
			if ( value.equals("userdata") && ( flag.equals("vector")) ) {
				
				NodeList itemList =  docList.item(i).getChildNodes();
				Vector <HashMap <String, String>> v = new Vector <HashMap <String, String>>();
				for (int j = 0; j < itemList.getLength(); j++) {
					NodeList elementList = itemList.item(j).getChildNodes();
					HashMap <String, String> hm = new HashMap <String, String>();
					for (int k = 0; k < elementList.getLength(); k++) {
						NamedNodeMap usermap = elementList.item(k).getAttributes();
						key = usermap.getNamedItem("key").getNodeValue();
						value = usermap.getNamedItem("value").getNodeValue();
						if (key.equals("send_id")) hm.put(key, value);
						if (key.equals("recv_id")) hm.put(key, value);
						if (key.equals("date")) hm.put(key, value);
						if (key.equals("title")) hm.put(key, value);
						if (key.equals("text")) hm.put(key, value);
						if (key.equals("isshort")) hm.put(key, value);
					}
					v.add(hm);
				}
				result = v;
			}
			if ( value.equals("userdata") && ( flag.equals("text")) ) {
				Node itemNode =  docList.item(i).getFirstChild().getFirstChild();
				NamedNodeMap textmap =itemNode.getAttributes();
				result = textmap.getNamedItem("value").getNodeValue();
			}
			if ( value.equals("userdata") && ( flag.equals("empty")) ) {
				result = null;
			}
		}


		return result;
	
	}
}
