package ju.thecompany.server.controlserver.serverprocess;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;

import javax.xml.stream.XMLStreamException;

import ju.thecompany.data.CodeDesc;
import ju.thecompany.data.DateParser;
import ju.thecompany.data.Setting;
import ju.thecompany.data.TCXMLParser;
import ju.thecompany.data.TheCompanyDataToken;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMember;

public class ConnectionStatus extends Thread{
	@Override
	public void run() {
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e1) {
			e1.printStackTrace();
		}
		startReader();
	}
	
    public void startReader() {
    	Thread conThread = new Thread(null, threadConnProcess, "Background1" );
    	conThread.start();
    	Thread conOKThread = new Thread(null, threadConnOKProcess, "Background1" );
    	conOKThread.start();
    }
    
	private Runnable threadConnProcess = new Runnable() {
		@Override
		public void run() {
			SocketChannel sc = null;
			
			try {
				Selector seletor = Selector.open();
				
				String serverip = Setting.getInstance().getData("ControlServerIP");
				int serverport = Integer.parseInt(Setting.getInstance().getData("ControlServerPort"));
				
				sc = SocketChannel.open(new InetSocketAddress(serverip, serverport));
				sc.configureBlocking(false); 
				sc.register(seletor, SelectionKey.OP_WRITE);
				
				while (!Thread.currentThread().isInterrupted()) {

					seletor.select();
					
					Iterator it = seletor.selectedKeys().iterator();
					while (it.hasNext()) {
						SelectionKey key = (SelectionKey) it.next();

							if (key.isWritable()) {
								writeCon(key);
							}

						it.remove();
					}
					try {
						Thread.sleep(5000);
					} catch (InterruptedException ex) {
						ex.printStackTrace();
					}
				}      
			} catch (Exception e) {
				e.printStackTrace();
			} 
			finally {

			}
		}
	};
		
	private void writeCon(SelectionKey key) {
		SocketChannel sc = (SocketChannel) key.channel();

		try {

			TheCompanyDataToken sendToken = new TheCompanyDataToken();
			TheCompanyDataToken recvToken = new TheCompanyDataToken();
			Object obj = null;

			if (!LoginMember.getInstance().isEmpty()) {
				sendToken.code = CodeDesc.CONNECT;

				String sendXML = TCXMLParser.parseString(sendToken, recvToken, obj);

				ByteBuffer encodedBuffer = ByteBuffer.wrap(sendXML.getBytes("UTF-8"));
				
				int bt = 0;
				
				while(encodedBuffer.hasRemaining()) {
					bt += sc.write(encodedBuffer);
				}
				
				encodedBuffer = null;

			}
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (XMLStreamException e) {
			e.printStackTrace();
		} finally {
			//if (sc != null)try {sc.close();} catch (IOException e) {e.printStackTrace();}
		}
		
		
	}
	
	private Runnable threadConnOKProcess = new Runnable() {
		@Override
		public void run() {
			SocketChannel sc = null;
			
			try {
				Selector seletor = Selector.open();
				
				String serverip = Setting.getInstance().getData("ControlServerIP");
				int serverport = Integer.parseInt(Setting.getInstance().getData("ControlServerPort"));
				
				sc = SocketChannel.open(new InetSocketAddress(serverip, serverport));
				sc.configureBlocking(false); 
				sc.register(seletor, SelectionKey.OP_WRITE);
				
				while (!Thread.currentThread().isInterrupted()) {

					seletor.select();
					
					Iterator it = seletor.selectedKeys().iterator();
					while (it.hasNext()) {
						SelectionKey key = (SelectionKey) it.next();

							if (key.isWritable()) {
								writeLogout(key);
							}

						it.remove();
					}							
					try {
						Thread.sleep(5000);
					} catch (InterruptedException ex) {
						ex.printStackTrace();
					}
				}      
			} catch (Exception e) {
				e.printStackTrace();
			} 
			finally {

			}
		}
	};
		
	private void writeLogout(SelectionKey key) {
		SocketChannel sc = (SocketChannel) key.channel();
		
		TheCompanyDataToken sendToken = new TheCompanyDataToken();
		TheCompanyDataToken recvToken = new TheCompanyDataToken();
		Object obj = null;

		try {
			long time = System.currentTimeMillis();
			
			Enumeration <String>e = LoginMember.getInstance().keys();
			
			if (e!=null) {
				while (e.hasMoreElements()) {

					String id = e.nextElement();

					Date date = (Date)LoginMember.getInstance().getConnMember(id).get(1);
							
					long gab = time - date.getTime();
							
					if (gab > 7000L) {
						
						sendToken.code = CodeDesc.LOGOUT;
						sendToken.id = id;
						
						String sendXML = TCXMLParser.parseString(sendToken, recvToken, obj);
		
						ByteBuffer encodedBuffer = ByteBuffer.wrap(sendXML.getBytes("UTF-8"));
						
						int bt = 0;
						
						while(encodedBuffer.hasRemaining()) {
							bt += sc.write(encodedBuffer);
						}
						
						encodedBuffer = null;
					}
				}
			
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (XMLStreamException e) {
			e.printStackTrace();
		} finally {
			//if (sc != null)try {sc.close();} catch (IOException e) {e.printStackTrace();}
		}
		
		
	}
}
