// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18

package ju.thecompany.server.controlserver.serverprocess;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;

import ju.thecompany.data.ByteStream;
import ju.thecompany.data.Setting;

// 파일 전송용 블록킹 서버
public class FileBlockingServer extends Thread{
	private BufferedReader br = null;;
	private InputStream is = null;
	private ServerSocket serverSocket = null;
    private Socket socket = null;
    
	@Override
	public void run() {
		 try {
		    	serverSocket = new ServerSocket(Integer.parseInt(Setting.getInstance().getData("ControlServerFilePort")));
		    	serverSocket.setSoTimeout(3000);
		    	while (!Thread.currentThread().isInterrupted()) {
			    	try {
			    		socket = serverSocket.accept();
			    		processDownload();
			    	} catch (SocketTimeoutException e) { 
			    		//if (Thread.currentThread().isInterrupted()) break;
			    	}
					
		    	}	        
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (is != null) try { is.close(); } catch (IOException e) {e.printStackTrace();}
				if (br != null) try { br.close(); } catch (IOException e) {e.printStackTrace();}
				if (socket != null) try { socket.close(); } catch (IOException e) {e.printStackTrace();}
				if (serverSocket != null) try { serverSocket.close(); } catch (IOException e) {e.printStackTrace();}

			}
	}
	
	public void processDownload() {
		
		try {
			is = socket.getInputStream();
			int nof_files = ByteStream.toInt(is);
			
			for (int cur_file=0;cur_file < nof_files; cur_file++) {
				
				String file_name = ByteStream.toString(is);
				File file=new File("pic/" + file_name);
				ByteStream.toFile(is, file);
				
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
