package ju.thecompany.server.controlserver.serverprocess.pool.selector;


import java.io.IOException;
import java.nio.channels.Selector;
import java.util.Iterator;

import ju.thecompany.data.Setting;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.Queue;
import ju.thecompany.server.controlserver.serverprocess.pool.selector.handler.AcceptHandler;

// AcceptHandler를 생성하여 저장
public class AcceptSelectorPool extends SelectorPoolAdaptor {
	
	private int port = 9090;
	private Queue queue = null;
	
	public AcceptSelectorPool(Queue queue) {
		this(queue, 1);
	}
	
	public AcceptSelectorPool(Queue queue, int size) {
		super.size = size;		
		this.queue = queue;
		Setting setting = Setting.getInstance();
		this.port = Integer.parseInt(setting.getData("ControlServerPort"));
		init();
	}
	
	private void init() {
		for (int i = 0; i < size; i++) {
			pool.add(createHandler(i));
		}
	}
	
	protected Thread createHandler(int index) {
		Selector selector = null;
		try {
			selector = Selector.open();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		Thread handler = new AcceptHandler(queue, selector, port, index);
		
		return handler;
	}

	public void startAll() {
		Iterator iter = pool.iterator();
		while (iter.hasNext()) {
			Thread handler = (Thread) iter.next();
			handler.start();
		}
	}


	public void stopAll() {
		Iterator iter = pool.iterator();
		while (iter.hasNext()) {
			Thread handler = (Thread) iter.next();
			handler.interrupt();
			handler = null;
		}
	}

}
