package ju.thecompany.server.controlserver.serverprocess.pool.thread.processor;


import java.nio.channels.SocketChannel;

import ju.thecompany.server.controlserver.serverprocess.event.Job;
import ju.thecompany.server.controlserver.serverprocess.event.NIOEvent;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.Queue;
import ju.thecompany.server.controlserver.serverprocess.pool.PoolManager;
import ju.thecompany.server.controlserver.serverprocess.pool.selector.handler.HandlerAdaptor;

// ACCEPT_EVENT의 잡을 빼내서 논블록으로 만든 후 RequestSelector에 넣음.
public class AcceptProcessor extends Thread {
	
	private Queue queue = null;
	
	public AcceptProcessor(Queue queue) {
		this.queue = queue;
	}
	
	public void run() {
		try {
			while (!Thread.currentThread().isInterrupted()) {
				Job job = queue.pop(NIOEvent.ACCEPT_EVENT);
				SocketChannel sc = (SocketChannel) job.getSession().get("SocketChannel");
				sc.configureBlocking(false);
				HandlerAdaptor handler = (HandlerAdaptor) PoolManager.getRequestSelectorPool().get();
				handler.addClient(sc);
			}
		} catch (Exception e) {
			//e.printStackTrace();
		}
	}

}
