package ju.thecompany.server.controlserver.serverprocess.task;

import java.nio.channels.SocketChannel;
import java.util.ArrayList;
import java.util.Date;

import ju.thecompany.data.TheCompanyDataToken;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMember;

public class ConnectOKTask extends AbstractTask{

	public  ConnectOKTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {

		long time = System.currentTimeMillis();
		Date systemTime = new Date();
		systemTime.setTime(time);

		LoginMember.getInstance().setConnMember(sendToken.id, sc, systemTime);
		
		isBroadcast = false;
		isSendXML = false;
	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}

	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
}
