package ju.thecompany.server.controlserver.serverprocess.task;

import java.nio.channels.SocketChannel;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import ju.thecompany.data.CodeDesc;
import ju.thecompany.data.DateParser;
import ju.thecompany.data.Setting;
import ju.thecompany.data.TheCompanyDataToken;
import  ju.thecompany.server.controlserver.dbprocess.DBControl;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.Connections;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMember;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMemberData;

public class LoginReqTask extends AbstractTask{

	public  LoginReqTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {
		Setting setting = Setting.getInstance();
		DBControl dbc = DBControl.getInstance();
		
		try {
			if (dbc.Login(sendToken.id, (String)obj)) {

				String id = sendToken.id;
				String ip = sc.socket().getInetAddress().getHostAddress();
				String port = "" + sendToken.port;
				
				dbc.setChkLogin(id, true);
				
				long time = System.currentTimeMillis();
				Date systemTime = new Date();
				systemTime.setTime(time);
				
				LoginMemberData.getInstance().addMember(id, ip, port);
				LoginMember.getInstance().setConnMember(id, sc, systemTime);
				
				recvToken.id = id;
				
				sendToken.code = CodeDesc.LOGIN_OK;
				sendToken.ip = sc.socket().getLocalAddress().getHostAddress();
				sendToken.port = sc.socket().getLocalPort();

				sendToken.date = DateParser.dateToString(systemTime);
				
				Vector <HashMap<String, String>> v = dbc.GetUserList();
				Iterator<HashMap<String, String>> i = v.iterator();
				Hashtable <String, ArrayList<String>> ht = new Hashtable <String, ArrayList<String>>();
				
				while(i.hasNext()) {
					HashMap<String, String> hm = i.next();
					ArrayList <String> al = new ArrayList <String>(8);
					String userId = hm.get("id");
					if (LoginMemberData.getInstance().containsKey(userId)) {
						al.addAll(0, LoginMemberData.getInstance().get(userId));
						al.add(2, hm.get("name"));
						al.add(3, hm.get("deptname"));
						al.add(4, hm.get("hp"));
						al.add(5, hm.get("logoutdate"));
						al.add(6, hm.get("chklogin"));
						al.add(7, hm.get("pic"));
					} else {
						al.add(0, "");
						al.add(1, "");
						al.add(2, hm.get("name"));
						al.add(3, hm.get("deptname"));
						al.add(4, hm.get("hp"));
						al.add(5, hm.get("logoutdate"));
						al.add(6, hm.get("chklogin"));
						al.add(7, hm.get("pic"));
					}
					
					
					ht.put(userId, al);
				}
				
				obj = ht;

			}
			else {
				recvToken.id = sendToken.id;
				
				sendToken.code = CodeDesc.LOGIN_NO;
				sendToken.ip = sc.socket().getLocalAddress().getHostAddress();
				sendToken.port = sc.socket().getLocalPort();
				
				long time = System.currentTimeMillis();
				Date systemTime = new Date();
				systemTime.setTime(time);
				sendToken.date = DateParser.dateToString(systemTime);
				
				obj = null;
				
				Connections.getInstance().remove(sc);
			}
			isSendXML = true;
		} catch (SQLException e) {
			sendToken = null;
			recvToken = null;
			obj = null;
			isSendXML = false;
		}
		
	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}
	
	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
}
