package ju.thecompany.server.controlserver.serverprocess.task;

import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.nio.channels.SocketChannel;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import ju.thecompany.data.ByteStream;
import ju.thecompany.data.CodeDesc;
import ju.thecompany.data.DateParser;
import ju.thecompany.data.Setting;
import ju.thecompany.data.TheCompanyDataToken;
import  ju.thecompany.server.controlserver.dbprocess.DBControl;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMemberData;

public class LoginTask extends AbstractTask{

	public  LoginTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {
		Setting setting = Setting.getInstance();
		DBControl dbc = DBControl.getInstance();

		String id = sendToken.id;
		
		HashMap<String, String> hm = null;
		try {
			hm = dbc.GetUser(id);
			
			ArrayList <String> al = new ArrayList <String>();
			al.addAll(0, LoginMemberData.getInstance().get(id));
			al.add(hm.get("name"));
			al.add(hm.get("deptname"));
			al.add(hm.get("hp"));
			al.add(hm.get("logoutdate"));
			al.add(hm.get("chklogin"));
			al.add(hm.get("pic"));

			Hashtable <String, ArrayList<String>> ht = new Hashtable <String, ArrayList<String>>(1);
			
			ht.put(id, al);
			
			sendToken.code = CodeDesc.LOGIN_SUCCESS;
			sendToken.ip = sc.socket().getLocalAddress().getHostAddress();
			sendToken.port = sc.socket().getLocalPort();
			
			long time = System.currentTimeMillis();
			Date systemTime = new Date();
			systemTime.setTime(time);
			sendToken.date = DateParser.dateToString(systemTime);
			
			recvToken.id = id;
			
			obj = ht;
			isBroadcast = true;
			isSendXML = true;
		
			
			Thread t = new SendPic(id);
			t.start();

		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}

	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
	
	class SendPic extends Thread {
		
		private String id;
		
		public SendPic(String id) {
			this.id = id;
		}
		
		@Override
		public void run() {
			
			DBControl dbc = DBControl.getInstance();
			ArrayList <String> filenames = new ArrayList<String>();
			
			String ip = LoginMemberData.getInstance().get(id).get(0);
			int port = Integer.parseInt(LoginMemberData.getInstance().get(id).get(1));
			
			Vector<HashMap<String, String>> v;
			OutputStream os = null;
			File contentsFile = null;
			Socket socket = null;
			
			try {
				v = dbc.GetUserList();
				
				Iterator<HashMap<String, String>> i = v.iterator();
				HashMap<String, String> hm = null;

				while(i.hasNext()) {
					hm = i.next();
					String filename = hm.get("pic");
					if (filename.equals("")) continue;

					contentsFile = new File("pic/" + filename);
					if (contentsFile.canRead() && contentsFile.exists()) {
						filenames.add(filename);
					}

				}
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} 
			
			try {
				socket = new Socket(ip, port);
				os = socket.getOutputStream();
				int cnt_files = filenames.size();
				
				ByteStream.toStream(os, cnt_files);
				
				for (int cur_file=0; cur_file<cnt_files; cur_file++) {
					ByteStream.toStream(os, filenames.get(cur_file));
			        ByteStream.toStream(os, new File("pic/" + filenames.get(cur_file)));
			      }

			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (os != null) try { os.close(); } catch (IOException e) {e.printStackTrace();}
				if (socket != null) try { socket.close(); } catch (IOException e) {e.printStackTrace();}
			}
		    
		}
	}
}
