package ju.thecompany.server.controlserver.serverprocess.task;

import java.io.IOException;
import java.nio.channels.SocketChannel;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;

import ju.thecompany.data.CodeDesc;
import ju.thecompany.data.DateParser;
import ju.thecompany.data.TheCompanyDataToken;
import  ju.thecompany.server.controlserver.dbprocess.DBControl;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.Connections;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMember;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMemberData;

public class LogoutTask extends AbstractTask{

	public  LogoutTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {
		
		String id = sendToken.id;

		
		sendToken.code = CodeDesc.LOGOUT_OK;
		sendToken.ip = sc.socket().getLocalAddress().getHostAddress();
		sendToken.port = sc.socket().getLocalPort();
		
		long time = System.currentTimeMillis();
		Date systemTime = new Date();
		systemTime.setTime(time);
		sendToken.date = DateParser.dateToString(systemTime);
		
		try {
			DBControl.getInstance().setLogoutDate(id, systemTime);
			DBControl.getInstance().setChkLogin(id, false);
		} catch (SQLException e1) {
			e1.printStackTrace();
		}
		
		HashMap<String, String> hm = null;
		try {
			hm = DBControl.getInstance().GetUser(id);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		ArrayList <String> al = new ArrayList <String>();
		al.addAll(0, LoginMemberData.getInstance().get(id));
		al.add(hm.get("name"));
		al.add(hm.get("deptname"));
		al.add(hm.get("hp"));
		al.add(hm.get("logoutdate"));
		al.add(hm.get("chklogin"));
		al.add(hm.get("pic"));

		Hashtable <String, ArrayList<String>> ht = new Hashtable <String, ArrayList<String>>(1);
		
		ht.put(id, al);

		obj = ht;
		
		SocketChannel socketChannel = (SocketChannel)LoginMember.getInstance().get(id).get(0);
		LoginMemberData.getInstance().remove(id);
		LoginMember.getInstance().remove(id);
		Connections.getInstance().remove(socketChannel);
		
		try {
			socketChannel.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		isBroadcast = true;
		isSendXML = true;
	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}

	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
}
