package ju.thecompany.server.controlserver.serverprocess.task;

import java.nio.channels.SocketChannel;
import java.sql.SQLException;
import java.util.Date;
import java.util.HashMap;
import java.util.Vector;

import ju.thecompany.data.CodeDesc;
import ju.thecompany.data.DateParser;
import ju.thecompany.data.TheCompanyDataToken;
import  ju.thecompany.server.controlserver.dbprocess.DBControl;

public class ShortMsgReqTask extends AbstractTask{

	public  ShortMsgReqTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {

		String id = sendToken.id;
		
		sendToken.code = CodeDesc.SHORTMSG_OK;
		sendToken.ip = sc.socket().getLocalAddress().getHostAddress();
		sendToken.port = sc.socket().getLocalPort();
		
		long time = System.currentTimeMillis();
		Date systemTime = new Date();
		systemTime.setTime(time);
		sendToken.date = DateParser.dateToString(systemTime);
		
		recvToken.id = id;
		obj = null;
		try {
			Vector<HashMap<String, String>> v = DBControl.getInstance().getShortNotice(id);
			if (v != null) obj = v;
			else obj = "noitem";
		} catch (SQLException e) {
			
			e.printStackTrace();
		}

		isBroadcast = false;
		isSendXML = true;
	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}

	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
}
