package ju.thecompany.server.controlserver.serverprocess.task;

import java.nio.channels.SocketChannel;
import java.sql.SQLException;

import ju.thecompany.data.TheCompanyDataToken;
import  ju.thecompany.server.controlserver.dbprocess.DBControl;
import ju.thecompany.server.controlserver.serverprocess.jobqueue.LoginMember;

public class ShortMsgTask extends AbstractTask{
	
	private static final String SEPT = "/!`/~";

	public  ShortMsgTask(TheCompanyDataToken sendToken, TheCompanyDataToken recvToken, Object obj, SocketChannel sc) {
		super(sendToken, recvToken, obj, sc);
		
		processTask();
	}
	
	private void processTask() {
		
		if (!LoginMember.getInstance().containsKey(recvToken.id)) {
			try {
				String []result = ((String)obj).split(SEPT);
				DBControl.getInstance().setShortNotice(sendToken.id, recvToken.id, result[0], result[1], true);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		else {
			isBroadcast = false;
			isSendXML = true;
		}

	}

	@Override
	public TheCompanyDataToken getSendToken() {
		return sendToken;
	}

	@Override
	public TheCompanyDataToken getRecvToken() {
		return recvToken;
	}

	@Override
	public Object getObject() {
		return obj;
	}
	
	@Override
	public boolean isBroadcast() {
		return isBroadcast;
	}

	@Override
	public boolean isSendXML() {
		return isSendXML;
	}
}
