// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.client;

import ju.thecompany.web.client.data.SessionId;
import ju.thecompany.web.client.rpc.service.SessionService;
import ju.thecompany.web.client.rpc.service.SessionServiceAsync;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextBox;

public class BottomPanel extends HorizontalPanel {

	private static BottomPanel singleton = new BottomPanel();
	
	private BottomPanel() {
		
		validateSession();
	}
	
	public static BottomPanel getInstance() {
		return singleton;
	}
	
	// 새션을 확인하여 첫 화면을 결정
    private void validateSession(){
    	
        SessionServiceAsync myServiceAsync = (SessionServiceAsync)GWT.create(SessionService.class);
	    ServiceDefTarget serviceDefTarget = (ServiceDefTarget)myServiceAsync;
        serviceDefTarget.setServiceEntryPoint("session");

        AsyncCallback<SessionId> asyncCallback = new AsyncCallback<SessionId>(){
        	public void onFailure(Throwable caught) {
        		System.out.println(caught);
        	}
        	public void onSuccess(SessionId result) {
        		if(result == null){
        			changeMode(false);
                    System.out.println("1");
                }else if(!TheCompanyWeb.sessionId.getSessionId().equals(result.getSessionId())){
                	changeMode(false);
                    System.out.println("2");
                }else if(TheCompanyWeb.sessionId.getSessionId().equals(result.getSessionId())){
                	changeMode(true);
                    System.out.println("3");
                }
            }
        };
        myServiceAsync.session(TheCompanyWeb.sessionId, asyncCallback);
    }
	
    private void setLoginPanel() {
		setSize("100%", "100%");
		
		TextBox titleSite = new TextBox();
		titleSite.setReadOnly(true);
		titleSite.setText("LOCK!");
		titleSite.addStyleName("lockText_login");
		
		setStyleName("bottomPanel_login");
		
		DecoratorPanel dp = new DecoratorPanel();
		dp.setWidget(titleSite);
		dp.setSize("100%", "100%");
		dp.setStyleName("bottomPanel_login");
		
		add(dp);
    }
    
    private void setSuccessPanel() {
    	setSize("100%", "100%");
    	
		setStyleName("bottomPanel_success");
		
		clear();
		add(BottomMenuPanel.getInstance());
		add(BottomTablePanel.getInstance());

    }
    
    public void changeMode(boolean mode) {
    	
    	// true 완료, false 로그인
    	clear();

    	if (mode) setSuccessPanel();
    	else setLoginPanel();
    }

}
