// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.client;

import ju.thecompany.web.client.data.SessionId;
import ju.thecompany.web.client.rpc.service.SessionService;
import ju.thecompany.web.client.rpc.service.SessionServiceAsync;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.*;


public class TopPanel extends HorizontalPanel {

	private static TopPanel singleton = new TopPanel();

	private TopPanel() {
		validateSession();
	}
	
	public static TopPanel getInstance() {
		return singleton;
	}

	// 세션에 따른 화면 바뀜
    private void validateSession(){
    	
        SessionServiceAsync myServiceAsync = (SessionServiceAsync)GWT.create(SessionService.class);
	    ServiceDefTarget serviceDefTarget = (ServiceDefTarget)myServiceAsync;
        serviceDefTarget.setServiceEntryPoint("session");

        AsyncCallback<SessionId> asyncCallback = new AsyncCallback<SessionId>(){
        	public void onFailure(Throwable caught) {
        		System.out.println(caught);
        	}
        	public void onSuccess(SessionId result) {
        		if(result == null){
        			changeMode(false);
                }else if(!TheCompanyWeb.sessionId.getSessionId().equals(result.getSessionId())){
                	changeMode(false);
                }else if(TheCompanyWeb.sessionId.getSessionId().equals(result.getSessionId())){
                	changeMode(true);
                }
            }
        };
        myServiceAsync.session(TheCompanyWeb.sessionId, asyncCallback);
    }

    private void setLoginPanel() {
		setSize("1024px", "100%");
		setStyleName("topPanel_login");

		HTML titleSite = new HTML("The Company 0.4");
		titleSite.addStyleName("titleText_login");
		titleSite.setSize("670px", "50px");

		add(titleSite);
		add(LoginPanel.getInstance());
    }
    
    private void setSuccessPanel() {
    	setSize("1024px", "100%");
		setStyleName("topPanel_success");
		
		HTML titleSite = new HTML("Welcome to The Company");
		titleSite.setStyleName("titleText_success");
		titleSite.setSize("670px", "50px");

		add(titleSite);
		add(LoginPanel.getInstance());
    }
    
    public void changeMode(boolean mode) {
    	
    	// true 완료, false 로그인
    	clear();
    	
    	if (mode) setSuccessPanel();
    	else setLoginPanel();
    }

}
