// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.server;

import java.io.*;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.*;
import java.util.regex.*;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.*;

import javax.servlet.*;
import javax.servlet.http.*;

import ju.thecompany.web.server.util.ByteStream;
import ju.thecompany.web.server.util.Setting;

public class FileUpload extends HttpServlet{

	private static final long serialVersionUID = -6511834378633329316L;

	public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		PrintWriter out = response.getWriter();
		boolean isMultipart = ServletFileUpload.isMultipartContent(request);

		if (!isMultipart) {
      
		} else {
	      FileItemFactory factory = new DiskFileItemFactory();
	      ServletFileUpload upload = new ServletFileUpload(factory);
	      List items = null;
      try {
        items = upload.parseRequest(request);
      } catch (FileUploadException e) {
        e.printStackTrace();
      }
      Iterator itr = items.iterator();
      while (itr.hasNext()) {
        FileItem item = (FileItem) itr.next();
        if (item.isFormField()){
          String name = item.getFieldName();
          String value = item.getString();
        } else {
          try {
            String itemName = item.getName();
            Random generator = new Random();
            int r = Math.abs(generator.nextInt());

            String reg = "[.*]";
            String replacingtext = "";
            Pattern pattern = Pattern.compile(reg);
            Matcher matcher = pattern.matcher(itemName);
            StringBuffer buffer = new StringBuffer();

            while (matcher.find()) {
              matcher.appendReplacement(buffer, replacingtext);
            }
            int IndexOf = itemName.indexOf("."); 
            String domainName = itemName.substring(IndexOf);
            String finalimage = buffer.toString()+"_"+r+domainName;
            File savedFile = new File(Setting.getInstance().getData("PicPath")+finalimage.trim());
            item.write(savedFile);
            out.println(finalimage);
            
			OutputStream os = null;
			Socket socket = null;
            
            try {
				socket = new Socket(Setting.getInstance().getData("ControlServerIP"), 
						Integer.parseInt(Setting.getInstance().getData("ControlServerPort")));
				
				os = socket.getOutputStream();
				int cnt_files = 1;
				
				ByteStream.toStream(os, cnt_files);
				
				for (int cur_file=0; cur_file<cnt_files; cur_file++) {
					ByteStream.toStream(os, finalimage);
			        ByteStream.toStream(os, new File(Setting.getInstance().getData("PicPath")+finalimage));			      
				}

			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (os != null) try { os.close(); } catch (IOException e) {e.printStackTrace();}
				if (socket != null) try { socket.close(); } catch (IOException e) {e.printStackTrace();}
			}

          } catch (Exception e) {
            e.printStackTrace();
          }
        }
      }
    }
  }
} 