// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.server.rpc.service;

import java.sql.SQLException;
import java.util.Vector;

import ju.thecompany.web.client.data.DeptInfo;
import ju.thecompany.web.client.rpc.service.DeptService;
import ju.thecompany.web.db.DBUtil;


import com.google.gwt.user.server.rpc.RemoteServiceServlet;

// 부서 서비스
public class DeptServiceImpl extends RemoteServiceServlet implements DeptService{

	private static final long serialVersionUID = 1477997997104195342L;
	
	// 부서 리스트 획득
	public Vector<DeptInfo> getDeptList() {
		Vector<DeptInfo> result = null;
    	try {
        	result = DBUtil.getDeptList();
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
    }
	
	// 부서 추가
	public boolean insertDept(DeptInfo dept) {
		boolean result = false;
    	try {
        	DBUtil.insertDept(dept);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}
	
	// 부서 삭제
	public boolean deleteDept(DeptInfo dept) {
		boolean result = false;
    	try {
        	DBUtil.deleteDept(dept);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}
	
	// 부서 수정
	public boolean updateDept(DeptInfo dept, DeptInfo oridept) {
		boolean result = false;
    	try {
        	DBUtil.updateDept(dept, oridept);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
	}
}
