// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.server.rpc.service;

import java.sql.SQLException;
import java.util.Vector;

import ju.thecompany.web.client.data.PosInfo;
import ju.thecompany.web.client.rpc.service.PosService;
import ju.thecompany.web.db.DBUtil;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

// 직책 서비스
public class PosServiceImpl extends RemoteServiceServlet implements PosService{

	private static final long serialVersionUID = 1477997997104195342L;

	// 직책 리스트 획득
	public Vector<PosInfo> getPosList() {
		Vector<PosInfo> result = null;
    	try {
        	result = DBUtil.getPosList();
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
    }
	
	// 직책 추가
	public boolean insertPos(PosInfo pos) {
		boolean result = false;
    	try {
        	DBUtil.insertPos(pos);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}

	// 직책 삭제
	public boolean deletePos(PosInfo pos) {
		boolean result = false;
    	try {
        	DBUtil.deletePos(pos);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}

	// 직책 수정
	public boolean updatePos(PosInfo pos, PosInfo oripos) {
		boolean result = false;
    	try {
        	DBUtil.updatePos(pos, oripos);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
	}
}
