// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.web.server.rpc.service;

import java.sql.SQLException;
import java.util.Vector;

import ju.thecompany.web.client.data.UserInfo;
import ju.thecompany.web.client.rpc.service.UserService;
import ju.thecompany.web.db.DBUtil;


import com.google.gwt.user.server.rpc.RemoteServiceServlet;

// 유저 서비스
public class UserServiceImpl extends RemoteServiceServlet implements UserService{

	private static final long serialVersionUID = 1477997997104195342L;

	// 유저리스트 획득
	public Vector<UserInfo> getUserList(String sort) {
		Vector<UserInfo> result = null;
    	try {
        	result = DBUtil.getUserList(sort);
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
    }
	
	// 유저 추가
	public boolean insertUser(UserInfo user) {
		boolean result = false;
    	try {
        	DBUtil.insertUser(user);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}
	
	// 유저 삭제
	public boolean deleteUser(String id) {
		boolean result = false;
    	try {
        	DBUtil.deleteUser(id);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;	
	}

	// 유저 수정
	public boolean updateUser(UserInfo user) {
		boolean result = false;
    	try {
        	DBUtil.updateUser(user);
        	result = true;
		} catch (SQLException e) {
			e.printStackTrace();
		}
    	return result;
	}
}
