// License : Apache License v2.0
// Juhyun Lee (xog2000@gmail.com)
// 2009/10/18
//

package ju.thecompany.data;

import java.util.Hashtable;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;

public class Setting {
	
	private static Setting singleton = new Setting();
	private Hashtable<String, String> settingStorage;
	
	private Setting() {
		settingStorage = new Hashtable<String, String>();
		addSetting();
	}
	
	public static Setting getInstance() {
		return singleton ;
	}
	
	private void addSetting() {
		try {
			DocumentBuilder documentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document doc = documentBuilder.parse("./setting/setting.xml");
			NodeList nodeList = doc.getDocumentElement().getElementsByTagName("env");
			
			for ( int i = 0; i < nodeList.getLength(); i++ ) {
				NamedNodeMap namedNodeMap = nodeList.item(i).getAttributes();
				String key = namedNodeMap.getNamedItem("key").getNodeValue();
				settingStorage.put(key, (String)namedNodeMap.getNamedItem("value").getNodeValue());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public String getData(String key) {
		if ( !settingStorage.isEmpty() && settingStorage.containsKey(key))
			return (String)settingStorage.get(key);
		else 
			return null;
	}
	
	public Boolean isEmpty() {
		return settingStorage.isEmpty();
	}	
}
